package cn.iflyos.open.library;

import com.iflytek.home.sdk.R;

import java.io.IOException;
import java.io.InputStream;

@SuppressWarnings({"WeakerAccess", "unused"})
public class DecoderConfig {

    static {
        QuietInit.init();
    }

    long profile_ptr;

    public DecoderConfig(android.content.Context c, String key) throws IOException {
        profile_ptr = nativeOpen(getDefaultProfiles(c), key);
    }

    public DecoderConfig(String profiles, String key) {
        profile_ptr = nativeOpen(profiles, key);
    }

    public static String getDefaultProfiles(android.content.Context c) throws IOException {
        InputStream s = c.getResources().openRawResource(R.raw.quiet_profiles);
        byte[] profile_bytes = new byte[s.available()];
        s.read(profile_bytes);
        s.close();
        return new String(profile_bytes);
    }

    private native long nativeOpen(String profiles, String key);

    private native void nativeFree();

    @Override
    protected void finalize() {
        nativeFree();
    }

}
