package cn.iflyos.open.library;

import java.io.IOException;

@SuppressWarnings("unused")
public class QuietDecoder {

    static {
        QuietInit.init();
    }

    @SuppressWarnings("FieldCanBeLocal")
    private long dec_ptr;

    public QuietDecoder(DecoderConfig conf, int sampleRate) throws ModemException {
        this.dec_ptr = nativeCreate(conf, sampleRate);
    }

    private native long nativeCreate(DecoderConfig conf, int sampleRate) throws ModemException;

    private native void nativeDestroy();

    private native void nativeConsume(float[] sample, long offset, long length) throws IOException;

    private native void nativeConsumeBytes(byte[] sample, long offset, long length) throws IOException;

    private native void nativeFlush();

    private native long nativeReceive(byte[] frame, long offset, long length) throws IOException;

    public void consume(float[] sample) throws IOException {
        this.nativeConsume(sample, 0, sample.length);
    }

    public void consume(float[] sample, long offset, long length) throws IOException {
        this.nativeConsume(sample, offset, length);
    }

    public void consume(byte[] sample) throws IOException {
        this.nativeConsumeBytes(sample, 0, sample.length);
    }

    public void consume(byte[] sample, long offset, long length) throws IOException {
        this.nativeConsumeBytes(sample, offset, length);
    }

    public void flush() {
        this.nativeFlush();
    }

    public long receive(byte[] frame) throws IOException {
        return this.nativeReceive(frame, 0, frame.length);
    }

    public long receive(byte[] frame, long offset, long length) throws IOException {
        return this.nativeReceive(frame, offset, length);
    }

    public void destroy() {
        this.nativeDestroy();
    }

}
