package cn.iflyos.open.library;

import java.io.IOException;

@SuppressWarnings("unused")
public class QuietEncoder {

    static {
        QuietInit.init();
    }

    @SuppressWarnings("FieldCanBeLocal")
    private long enc_ptr;

    public QuietEncoder(EncoderConfig conf, int sampleRate) throws ModemException {
        this.enc_ptr = nativeCreate(conf, sampleRate);
    }

    private native long nativeCreate(EncoderConfig conf, int sampleRate) throws ModemException;

    private native void nativeDestroy();

    private native long nativeSend(byte[] frame, long offset, long length) throws IOException;

    private native long nativeGetFrameLength();

    private native long nativeEmit(float[] sample, long offset, long length) throws IOException;

    private native long nativeEmitBytes(byte[] sample, long offset, long length) throws IOException;

    public long send(byte[] frame) throws IOException {
        return this.nativeSend(frame, 0, frame.length);
    }

    public long send(byte[] frame, long length) throws IOException {
        return this.nativeSend(frame, 0, length);
    }

    public long send(byte[] frame, long offset, long length) throws IOException {
        return this.nativeSend(frame, offset, length);
    }

    public long getFrameLength() {
        return this.nativeGetFrameLength();
    }

    public long emit(float[] sample) throws IOException {
        return this.nativeEmit(sample, 0, sample.length);
    }

    public long emit(float[] sample, long offset, long length) throws IOException {
        return this.nativeEmit(sample, offset, length);
    }

    public long emit(byte[] sample) throws IOException {
        return this.nativeEmitBytes(sample, 0, sample.length);
    }

    public long emit(byte[] sample, long offset, long length) throws IOException {
        return this.nativeEmitBytes(sample, offset, length);
    }

    public void destroy() {
        this.nativeDestroy();
    }

}
