package com.iflytek.cyber.home.sdk.demo

import android.os.Build
import android.os.Bundle
import android.view.MenuItem
import android.view.View
import androidx.appcompat.app.AlertDialog
import androidx.appcompat.app.AppCompatActivity
import com.google.gson.GsonBuilder
import com.google.gson.JsonParser
import kotlinx.android.synthetic.main.activity_result.*
import java.lang.Exception

class ResultActivity : AppCompatActivity() {
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        if (Build.VERSION.SDK_INT >= 23)
            window.decorView.systemUiVisibility = window.decorView.systemUiVisibility or View.SYSTEM_UI_FLAG_LIGHT_STATUS_BAR
        setContentView(R.layout.activity_result)

        val result = intent.getStringExtra("result")
        if (result.isNullOrEmpty()) {
            AlertDialog.Builder(this)
                    .setTitle("请求出错")
                    .setMessage("未接受到响应体")
                    .setPositiveButton(android.R.string.yes) { _, _ -> finish() }
                    .show()
        } else {
            supportActionBar?.title = "请求结果"
            supportActionBar?.setHomeButtonEnabled(true)
            supportActionBar?.setDisplayHomeAsUpEnabled(true)

            val gson = GsonBuilder().setPrettyPrinting().create()
            try {
                result_text.text = gson.toJson(JsonParser().parse(result).asJsonObject)
            } catch (e: Exception) {
                e.printStackTrace()
                try {
                    result_text.text = gson.toJson(JsonParser().parse(result).asJsonArray)
                } catch (e1: Exception) {
                    e.printStackTrace()
                    result_text.text = result
                }
            }
        }
    }

    override fun onOptionsItemSelected(item: MenuItem?): Boolean {
        when (item?.itemId) {
            android.R.id.home -> finish()
        }
        return super.onOptionsItemSelected(item)
    }
}